## mupdf 1.12.0+ds1

=== Makefile ===
# GNU Makefile

build ?= release

OUT := build/$(build)

default: all

# --- Configuration ---

include Makerules
include Makethird

# Do not specify CFLAGS or LIBS on the make invocation line - specify
# XCFLAGS or XLIBS instead. Make ignores any lines in the makefile that
# set a variable that was set on the command line.
CFLAGS += $(XCFLAGS) -Iinclude
LIBS += $(XLIBS) -lm

LIBS += $(FREETYPE_LIBS)
LIBS += $(HARFBUZZ_LIBS)
LIBS += $(JBIG2DEC_LIBS)
LIBS += $(JPEGXR_LIB)
LIBS += $(LCMS2_LIBS)
LIBS += $(LIBCRYPTO_LIBS)
LIBS += $(LIBJPEG_LIBS)
LIBS += $(LURATECH_LIBS)
LIBS += $(MUJS_LIBS)
LIBS += $(OPENJPEG_LIBS)
LIBS += $(ZLIB_LIBS)

CFLAGS += $(FREETYPE_CFLAGS)
CFLAGS += $(HARFBUZZ_CFLAGS)
CFLAGS += $(JBIG2DEC_CFLAGS)
CFLAGS += $(JPEGXR_CFLAGS)
CFLAGS += $(LCMS2_CFLAGS)
CFLAGS += $(LIBCRYPTO_CFLAGS)
CFLAGS += $(LIBJPEG_CFLAGS)
CFLAGS += $(LURATECH_CFLAGS)
CFLAGS += $(MUJS_CFLAGS)
CFLAGS += $(OPENJPEG_CFLAGS)
CFLAGS += $(ZLIB_CFLAGS)

ALL_DIR := $(OUT)/generated
ALL_DIR += $(OUT)/scripts
ALL_DIR += $(OUT)/source/fitz
ALL_DIR += $(OUT)/source/pdf
ALL_DIR += $(OUT)/source/xps
ALL_DIR += $(OUT)/source/svg
ALL_DIR += $(OUT)/source/cbz
ALL_DIR += $(OUT)/source/html
ALL_DIR += $(OUT)/source/gprf
ALL_DIR += $(OUT)/source/tools
ALL_DIR += $(OUT)/source/helpers
ALL_DIR += $(OUT)/source/helpers/mu-threads
ALL_DIR += $(OUT)/platform/x11
ALL_DIR += $(OUT)/platform/x11/curl
ALL_DIR += $(OUT)/platform/gl

# --- Commands ---

ifneq "$(verbose)" "yes"
QUIET_AR = @ echo ' ' ' ' AR $@ ;
QUIET_CC = @ echo ' ' ' ' CC $@ ;
QUIET_CXX = @ echo ' ' ' ' CXX $@ ;
QUIET_GEN = @ echo ' ' ' ' GEN $@ ;
QUIET_LINK = @ echo ' ' ' ' LINK $@ ;
QUIET_MKDIR = @ echo ' ' ' ' MKDIR $@ ;
QUIET_RM = @ echo ' ' ' ' RM $@ ;
QUIET_TAGS = @ echo ' ' ' ' TAGS $@ ;
QUIET_WINDRES = @ echo ' ' ' ' WINDRES $@ ;
endif

CC_CMD = $(QUIET_CC) $(CC) $(CFLAGS) -o $@ -c $<
CXX_CMD = $(QUIET_CXX) $(CXX) $(CFLAGS) -o $@ -c $<
AR_CMD = $(QUIET_AR) $(AR) cr $@ $^
LINK_CMD = $(QUIET_LINK) $(CC) $(LDFLAGS) -o $@ $^ $(LIBS)
MKDIR_CMD = $(QUIET_MKDIR) mkdir -p $@
RM_CMD = $(QUIET_RM) rm -f $@
TAGS_CMD = $(QUIET_TAGS) ctags $^
WINDRES_CMD = $(QUIET_WINDRES) $(WINDRES) $< $@

# --- Rules ---

$(ALL_DIR) $(OUT) generated :
	$(MKDIR_CMD)

$(OUT)/%.a :
	$(RM_CMD)
	$(AR_CMD)
	$(RANLIB_CMD)

$(OUT)/%.exe: $(OUT)/%.o | $(ALL_DIR)
	$(LINK_CMD)

$(OUT)/source/helpers/%.o : source/helpers/%.c | $(ALL_DIR)
	$(CC_CMD) $(THREADING_CFLAGS)

$(OUT)/source/tools/%.o : source/tools/%.c | $(ALL_DIR)
	$(CC_CMD) $(THREADING_CFLAGS)

$(OUT)/generated/%.o : generated/%.c | $(ALL_DIR)
	$(CC_CMD) -O0

$(OUT)/platform/x11/%.o : platform/x11/%.c | $(ALL_DIR)
	$(CC_CMD) $(X11_CFLAGS)

$(OUT)/platform/x11/%.o: platform/x11/%.rc | $(ALL_DIR)
	$(WINDRES_CMD)

$(OUT)/platform/x11/curl/%.o : platform/x11/%.c | $(ALL_DIR)
	$(CC_CMD) $(X11_CFLAGS) $(CURL_CFLAGS) -DHAVE_CURL

$(OUT)/platform/gl/%.o : platform/gl/%.c | $(ALL_DIR)
	$(CC_CMD) $(GLUT_CFLAGS)

$(OUT)/%.o : %.c | $(ALL_DIR)
	$(CC_CMD)

$(OUT)/%.o : %.cpp | $(ALL_DIR)
	$(CXX_CMD)

.PRECIOUS : $(OUT)/%.o # Keep intermediates from chained rules

# --- File lists ---

FITZ_HDR := include/mupdf/fitz.h $(wildcard include/mupdf/fitz/*.h)
PDF_HDR := include/mupdf/pdf.h $(wildcard include/mupdf/pdf/*.h)
THREAD_HDR := include/mupdf/helpers/mu-threads.h

FITZ_SRC := $(sort $(wildcard source/fitz/*.c))
PDF_SRC := $(sort $(wildcard source/pdf/*.c))
XPS_SRC := $(sort $(wildcard source/xps/*.c))
SVG_SRC := $(sort $(wildcard source/svg/*.c))
CBZ_SRC := $(sort $(wildcard source/cbz/*.c))
HTML_SRC := $(sort $(wildcard source/html/*.c))
GPRF_SRC := $(sort $(wildcard source/gprf/*.c))
THREAD_SRC := $(sort $(wildcard source/helpers/mu-threads/*.c))

FITZ_SRC_HDR := $(wildcard source/fitz/*.h)
PDF_SRC_HDR := $(wildcard source/pdf/*.h) source/pdf/pdf-name-table.h
XPS_SRC_HDR := $(wildcard source/xps/*.h)
SVG_SRC_HDR := $(wildcard source/svg/*.h)
HTML_SRC_HDR := $(wildcard source/html/*.h)
GPRF_SRC_HDR := $(wildcard source/gprf/*.h)

FITZ_OBJ := $(FITZ_SRC:%.c=$(OUT)/%.o)
PDF_OBJ := $(PDF_SRC:%.c=$(OUT)/%.o)
XPS_OBJ := $(XPS_SRC:%.c=$(OUT)/%.o)
SVG_OBJ := $(SVG_SRC:%.c=$(OUT)/%.o)
CBZ_OBJ := $(CBZ_SRC:%.c=$(OUT)/%.o)
HTML_OBJ := $(HTML_SRC:%.c=$(OUT)/%.o)
GPRF_OBJ := $(GPRF_SRC:%.c=$(OUT)/%.o)
THREAD_OBJ := $(THREAD_SRC:%.c=$(OUT)/%.o)

$(FITZ_OBJ) : $(FITZ_HDR) $(FITZ_SRC_HDR)
$(PDF_OBJ) : $(FITZ_HDR) $(PDF_HDR) $(PDF_SRC_HDR)
$(PDF_OBJ) : $(FITZ_SRC_HDR) # ugh, ugly hack for fitz-imp.h + colorspace-imp.h
$(XPS_OBJ) : $(FITZ_HDR) $(XPS_HDR) $(XPS_SRC_HDR)
$(XPS_OBJ) : $(FITZ_SRC_HDR) # ugh, ugly hack for fitz-imp.h
$(SVG_OBJ) : $(FITZ_HDR) $(SVG_HDR) $(SVG_SRC_HDR)
$(CBZ_OBJ) : $(FITZ_HDR) $(CBZ_HDR) $(CBZ_SRC_HDR)
$(HTML_OBJ) : $(FITZ_HDR) $(HTML_HDR) $(HTML_SRC_HDR)
$(GPRF_OBJ) : $(FITZ_HDR) $(GPRF_HDR) $(GPRF_SRC_HDR)
$(THREAD_OBJ) : $(THREAD_HDR)

# --- Generated PDF name tables ---

NAMEDUMP_EXE := $(OUT)/scripts/namedump.exe

include/mupdf/pdf.h : include/mupdf/pdf/name-table.h
NAME_GEN := include/mupdf/pdf/name-table.h source/pdf/pdf-name-table.h
$(NAME_GEN) : resources/pdf/names.txt
	$(QUIET_GEN) $(NAMEDUMP_EXE) resources/pdf/names.txt $(NAME_GEN)

ifneq "$(CROSSCOMPILE)" "yes"
$(NAME_GEN) : $(NAMEDUMP_EXE)
endif

$(OUT)/source/pdf/pdf-object.o : source/pdf/pdf-name-table.h

generate: $(NAME_GEN)

# --- Generated embedded font files ---

HEXDUMP_EXE := $(OUT)/scripts/hexdump.exe

FONT_BIN_DROID := $(sort $(wildcard resources/fonts/droid/*.ttf))
FONT_BIN_NOTO := $(sort $(wildcard resources/fonts/noto/*.ttf))
FONT_BIN_HAN := $(sort $(wildcard resources/fonts/han/*.otf))
FONT_BIN_URW := $(sort $(wildcard resources/fonts/urw/*.cff))
FONT_BIN_SIL := $(sort $(wildcard resources/fonts/sil/*.cff))

FONT_GEN_DROID := $(subst resources/fonts/droid/, generated/, $(addsuffix .c, $(basename $(FONT_BIN_DROID))))
FONT_GEN_NOTO := $(subst resources/fonts/noto/, generated/, $(addsuffix .c, $(basename $(FONT_BIN_NOTO))))
FONT_GEN_HAN := $(subst resources/fonts/han/, generated/, $(addsuffix .c, $(basename $(FONT_BIN_HAN))))
FONT_GEN_URW := $(subst resources/fonts/urw/, generated/, $(addsuffix .c, $(basename $(FONT_BIN_URW))))
FONT_GEN_SIL := $(subst resources/fonts/sil/, generated/, $(addsuffix .c, $(basename $(FONT_BIN_SIL))))

FONT_BIN := $(FONT_BIN_DROID) $(FONT_BIN_NOTO) $(FONT_BIN_HAN) $(FONT_BIN_URW) $(FONT_BIN_SIL)
FONT_GEN := $(FONT_GEN_DROID) $(FONT_GEN_NOTO) $(FONT_GEN_HAN) $(FONT_GEN_URW) $(FONT_GEN_SIL)
FONT_OBJ := $(FONT_GEN:%.c=$(OUT)/%.o)

generated/%.c : resources/fonts/droid/%.ttf $(HEXDUMP_EXE) | generated
	$(QUIET_GEN) $(HEXDUMP_EXE) -s $@ $<
generated/%.c : resources/fonts/noto/%.ttf $(HEXDUMP_EXE) | generated
	$(QUIET_GEN) $(HEXDUMP_EXE) -s $@ $<
generated/%.c : resources/fonts/han/%.otf $(HEXDUMP_EXE) | generated
	$(QUIET_GEN) $(HEXDUMP_EXE) -s $@ $<
generated/%.c : resources/fonts/urw/%.cff $(HEXDUMP_EXE) | generated
	$(QUIET_GEN) $(HEXDUMP_EXE) -s $@ $<
generated/%.c : resources/fonts/sil/%.cff $(HEXDUMP_EXE) | generated
	$(QUIET_GEN) $(HEXDUMP_EXE) -s $@ $<

$(FONT_OBJ) : $(FONT_GEN)
$(FONT_GEN_DROID) : $(FONT_BIN_DROID)
$(FONT_GEN_NOTO) : $(FONT_BIN_NOTO)
$(FONT_GEN_HAN) : $(FONT_BIN_HAN)
$(FONT_GEN_URW) : $(FONT_BIN_URW)
$(FONT_GEN_SIL) : $(FONT_BIN_SIL)

ifneq "$(CROSSCOMPILE)" "yes"
$(FONT_GEN) : $(HEXDUMP_EXE)
endif

generate: $(FONT_GEN)

# --- Generated ICC profiles ---

ICC_BIN := resources/icc/gray.icc resources/icc/rgb.icc resources/icc/cmyk.icc resources/icc/lab.icc
ICC_GEN := generated/icc-profiles.c
ICC_OBJ := $(ICC_GEN:%.c=$(OUT)/%.o)

$(ICC_OBJ) : $(ICC_GEN)
$(ICC_GEN) : $(ICC_BIN) | generated
	$(QUIET_GEN) $(HEXDUMP_EXE) $@ $(ICC_BIN)

ifneq "$(CROSSCOMPILE)" "yes"
$(ICC_GEN) : $(HEXDUMP_EXE)
endif

generate: $(ICC_GEN)

# --- Generated CMap files ---

CMAPDUMP_EXE := $(OUT)/scripts/cmapdump.exe

CMAP_CJK_SRC := $(sort $(wildcard resources/cmaps/cjk/*))
CMAP_EXTRA_SRC := $(sort $(wildcard resources/cmaps/extra/*))
CMAP_UTF8_SRC := $(sort $(wildcard resources/cmaps/utf8/*))
CMAP_UTF32_SRC := $(sort $(wildcard resources/cmaps/utf32/*))

CMAP_GEN := \
	generated/pdf-cmap-cjk.c \
	generated/pdf-cmap-extra.c \
	generated/pdf-cmap-utf8.c \
	generated/pdf-cmap-utf32.c
CMAP_OBJ := $(CMAP_GEN:%.c=$(OUT)/%.o)

generated/pdf-cmap-cjk.c : $(CMAP_CJK_SRC) | generated
	$(QUIET_GEN) $(CMAPDUMP_EXE) $@ $(CMAP_CJK_SRC)
generated/pdf-cmap-extra.c : $(CMAP_EXTRA_SRC) | generated
	$(QUIET_GEN) $(CMAPDUMP_EXE) $@ $(CMAP_EXTRA_SRC)
generated/pdf-cmap-utf8.c : $(CMAP_UTF8_SRC) | generated
	$(QUIET_GEN) $(CMAPDUMP_EXE) $@ $(CMAP_UTF8_SRC)
generated/pdf-cmap-utf32.c : $(CMAP_UTF32_SRC) | generated
	$(QUIET_GEN) $(CMAPDUMP_EXE) $@ $(CMAP_UTF32_SRC)

$(CMAP_OBJ) : $(CMAP_GEN)

ifneq "$(CROSSCOMPILE)" "yes"
$(CMAP_GEN) : $(CMAPDUMP_EXE)
endif

generate: $(CMAP_GEN)

$(OUT)/scripts/cmapdump.o : \
	$(NAME_GEN) \
	include/mupdf/pdf/cmap.h \
	source/fitz/context.c \
	source/fitz/error.c \
	source/fitz/memory.c \
	source/fitz/output.c \
	source/fitz/string.c \
	source/fitz/buffer.c \
	source/fitz/stream-open.c \
	source/fitz/stream-read.c \
	source/fitz/strtof.c \
	source/fitz/ftoa.c \
	source/fitz/printf.c \
	source/fitz/time.c \
	source/pdf/pdf-lex.c \
	source/pdf/pdf-cmap.c \
	source/pdf/pdf-cmap-parse.c \

# --- Generated embedded javascript files ---

JAVASCRIPT_SRC := source/pdf/pdf-js-util.js
JAVASCRIPT_GEN := generated/pdf-js-util.c
JAVASCRIPT_OBJ := $(JAVASCRIPT_GEN:%.c=$(OUT)/%.o)

$(JAVASCRIPT_GEN) : $(JAVASCRIPT_SRC) | generated
	$(QUIET_GEN) $(HEXDUMP_EXE) -0 $@ $(JAVASCRIPT_SRC)

ifneq "$(CROSSCOMPILE)" "yes"
$(JAVASCRIPT_GEN) : $(HEXDUMP_EXE)
endif

$(JAVASCRIPT_OBJ) : $(JAVASCRIPT_GEN)

generate: $(JAVASCRIPT_GEN)

# --- Library ---

MUPDF_LIB = $(OUT)/libmupdf.a
THIRD_LIB = $(OUT)/libmupdfthird.a
THREAD_LIB = $(OUT)/libmuthreads.a

MUPDF_OBJ := \
	$(FITZ_OBJ) \
	$(PDF_OBJ) \
	$(CMAP_OBJ) \
	$(FONT_OBJ) \
	$(JAVASCRIPT_OBJ) \
	$(XPS_OBJ) \
	$(SVG_OBJ) \
	$(CBZ_OBJ) \
	$(HTML_OBJ) \
	$(GPRF_OBJ) \
	$(ICC_OBJ)

THIRD_OBJ := \
	$(FREETYPE_OBJ) \
	$(HARFBUZZ_OBJ) \
	$(JBIG2DEC_OBJ) \
	$(JPEGXR_OBJ) \
	$(LIBJPEG_OBJ) \
	$(LURATECH_OBJ) \
	$(MUJS_OBJ) \
	$(OPENJPEG_OBJ) \
	$(ZLIB_OBJ) \
	$(LCMS2_OBJ)

THREAD_OBJ := $(THREAD_OBJ)

$(MUPDF_LIB) : $(MUPDF_OBJ)
$(THIRD_LIB) : $(THIRD_OBJ)
$(THREAD_LIB) : $(THREAD_OBJ)

INSTALL_LIBS := $(MUPDF_LIB) $(THIRD_LIB)

# --- Tools and Apps ---

MUTOOL_EXE := $(OUT)/mutool
MUTOOL_SRC := source/tools/mutool.c source/tools/muconvert.c source/tools/mudraw.c source/tools/murun.c source/tools/mutrace.c
MUTOOL_SRC += $(sort $(wildcard source/tools/pdf*.c))
MUTOOL_OBJ := $(MUTOOL_SRC:%.c=$(OUT)/%.o)
$(MUTOOL_OBJ) : $(FITZ_HDR) $(PDF_HDR)
$(MUTOOL_EXE) : $(MUTOOL_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(THREAD_LIB)
	$(LINK_CMD) $(THREADING_LIBS)

MURASTER_EXE := $(OUT)/muraster
MURASTER_OBJ := $(OUT)/source/tools/muraster.o
$(MURASTER_OBJ) : $(FITZ_HDR)
$(MURASTER_EXE) : $(MURASTER_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(THREAD_LIB)
	$(LINK_CMD) $(THREADING_LIBS)

MJSGEN_EXE := $(OUT)/mjsgen
MJSGEN_OBJ := $(OUT)/source/tools/mjsgen.o
$(MJSGEN_OBJ) : $(FITZ_HDR) $(PDF_HDR)
$(MJSGEN_EXE) : $(MJSGEN_OBJ) $(MUPDF_LIB) $(THIRD_LIB)
	$(LINK_CMD)

MUJSTEST_EXE := $(OUT)/mujstest
MUJSTEST_OBJ := $(addprefix $(OUT)/platform/x11/, jstest_main.o pdfapp.o)
$(MUJSTEST_OBJ) : $(FITZ_HDR) $(PDF_HDR)
$(MUJSTEST_EXE) : $(MUJSTEST_OBJ) $(MUPDF_LIB) $(THIRD_LIB)
	$(LINK_CMD)

ifeq "$(HAVE_X11)" "yes"
MUVIEW_X11_EXE := $(OUT)/mupdf-x11
MUVIEW_X11_OBJ := $(addprefix $(OUT)/platform/x11/, x11_main.o x11_image.o pdfapp.o)
$(MUVIEW_X11_OBJ) : $(FITZ_HDR) $(PDF_HDR)
$(MUVIEW_X11_EXE) : $(MUVIEW_X11_OBJ) $(MUPDF_LIB) $(THIRD_LIB)
	$(LINK_CMD) $(X11_LIBS)

ifeq "$(HAVE_CURL)" "yes"
MUVIEW_X11_CURL_EXE := $(OUT)/mupdf-x11-curl
MUVIEW_X11_CURL_OBJ := $(addprefix $(OUT)/platform/x11/curl/, x11_main.o x11_image.o pdfapp.o curl_stream.o)
$(MUVIEW_X11_CURL_OBJ) : $(FITZ_HDR) $(PDF_HDR)
$(MUVIEW_X11_CURL_EXE) : $(MUVIEW_X11_CURL_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(CURL_LIB)
	$(LINK_CMD) $(X11_LIBS) $(CURL_LIBS) $(SYS_CURL_DEPS)
endif
endif

ifeq "$(HAVE_GLUT)" "yes"
MUVIEW_GLUT_EXE := $(OUT)/mupdf-gl

=== platform/java/Makefile ===
OS ?= $(shell uname)

ifeq "$(OS)" "Darwin"
MUPDF_JAVA := libmupdf_java64.jnilib
JAVA_CFLAGS := \
	-I /Library/Java/JavaVirtualMachines/jdk1.8.0_66.jdk/Contents/Home/include \
	-I /Library/Java/JavaVirtualMachines/jdk1.8.0_66.jdk/Contents/Home/include/darwin
else

BITS := $(shell getconf LONG_BIT)

JAVA_HOME ?= /usr/lib/jvm/default-java

MUPDF_JAVA := libmupdf_java$(BITS).so
JAVA_CFLAGS := \
	-I $(JAVA_HOME)/include \
	-I $(JAVA_HOME)/include/linux \
	$(shell pkg-config --cflags freetype2) \
	$(shell pkg-config --cflags libcrypto)
JAVA_LIBS := \
	$(shell pkg-config --libs freetype2) \
	$(shell pkg-config --libs libcrypto) \
	-lz
endif

default: $(MUPDF_JAVA) libmupdf.jar

MUPDF_CORE := ../../build/java/libmupdf.a ../../build/java/libmupdfthird.a
ifeq "$(OS)" "Linux"
$(MUPDF_CORE) :
	$(MAKE) -C ../.. OUT=build/java XCFLAGS=-fPIC FREETYPE_DIR=/foo ZLIB_DIR=/foo libs
else
$(MUPDF_CORE) :
	$(MAKE) -C ../.. OUT=build/java XCFLAGS=-fPIC libs
endif

LIBRARY_JAVA_SOURCES := $(sort $(wildcard src/com/artifex/mupdf/fitz/*.java))
LIBRARY_JAVA_OBJECTS := $(LIBRARY_JAVA_SOURCES:%.java=%.class)
LIBRARY_JAVA_CLASSES := $(subst src/com/artifex/mupdf/fitz/,com.artifex.mupdf.fitz.,$(LIBRARY_JAVA_SOURCES:%.java=%))

JAVAC_FLAGS := $(JAVAC_XFLAGS) -source 1.7 -target 1.7

$(LIBRARY_JAVA_OBJECTS) : $(LIBRARY_JAVA_SOURCES)
	javac $(JAVAC_FLAGS) $^

EXAMPLE_JAVA_SOURCES := $(sort $(wildcard example/*.java))
EXAMPLE_JAVA_OBJECTS := $(EXAMPLE_JAVA_SOURCES:%.java=%.class)

$(EXAMPLE_JAVA_OBJECTS) : $(EXAMPLE_JAVA_SOURCES)
	javac $(JAVAC_FLAGS) -classpath .:src $^

libmupdf.jar : $(LIBRARY_JAVA_OBJECTS)
	rm -f $@
	jar cf $@ $^

mupdf_native.h : $(LIBRARY_JAVA_OBJECTS)
	rm -f $@
	javah -classpath .:src -o $@ $(LIBRARY_JAVA_CLASSES)

mupdf_native.o : mupdf_native.c mupdf_native.h $(MUPDF_CORE)
	$(CC) -g -o $@ -c $< -fPIC -Wall -Wextra -Wno-unused-parameter -I ../../include \
		$(JAVA_CFLAGS)

$(MUPDF_JAVA) : mupdf_native.o $(MUPDF_CORE)
	$(CC) -shared -o $(MUPDF_JAVA) $^ $(JAVA_LIBS)

run: $(MUPDF_JAVA) $(EXAMPLE_JAVA_OBJECTS)
	LD_LIBRARY_PATH=. java -classpath .:src example.Viewer

gdb: $(MUPDF_JAVA) $(EXAMPLE_JAVA_OBJECTS)
	LD_LIBRARY_PATH=. gdb --args java -classpath .:src example.Viewer

clean:
	rm -f src/com/artifex/mupdf/fitz/*.class
	rm -f example/*.class
	rm -f mupdf_native.o
	rm -f $(MUPDF_JAVA)

nuke: clean
	$(MAKE) -C ../.. OUT=build/java clean

.NOTPARALLEL : # disable -j option (it breaks since javac compiles all class files in one command)

=== thirdparty/mujs/Makefile ===
SRCS := $(wildcard js*.c utf*.c regexp.c)
HDRS := $(wildcard js*.h mujs.h utf.h regexp.h)
OBJS := $(SRCS:%.c=build/%.o)

prefix ?= /usr/local
bindir ?= $(prefix)/bin
incdir ?= $(prefix)/include
libdir ?= $(prefix)/lib

CFLAGS := -std=c99 -pedantic -Wall -Wextra -Wno-unused-parameter

ifeq "$(CC)" "clang"
CFLAGS += -Wunreachable-code
endif

ifeq "$(build)" "debug"
CFLAGS += -g
else
CFLAGS += -O2
endif

default: build build/mujs build/mujsone

debug:
	$(MAKE) build=debug

release:
	$(MAKE) build=release

astnames.h: jsparse.h
	grep -E '(AST|EXP|STM)_' jsparse.h | sed 's/^[^A-Z]*\(AST_\)*/"/;s/,.*/",/' | tr A-Z a-z > $@

opnames.h: jscompile.h
	grep -E 'OP_' jscompile.h | sed 's/^[^A-Z]*OP_/"/;s/,.*/",/' | tr A-Z a-z > $@

one.c: $(SRCS)
	ls $(SRCS) | awk '{print "#include \""$$1"\""}' > $@

jsdump.c: astnames.h opnames.h

build:
	mkdir -p build

build/%.o: %.c $(HDRS)
	$(CC) $(CFLAGS) -o $@ -c $<

build/libmujs.a: $(OBJS)
	$(AR) cru $@ $^

build/mujs: build/main.o build/libmujs.a
	$(CC) $(LDFLAGS) -o $@ $^ -lm

build/mujsone: build/main.o build/one.o
	$(CC) $(LDFLAGS) -o $@ $^ -lm

install: release
	install -d $(DESTDIR)$(incdir)
	install -d $(DESTDIR)$(libdir)
	install -d $(DESTDIR)$(bindir)
	install mujs.h $(DESTDIR)$(incdir)
	install build/libmujs.a $(DESTDIR)$(libdir)
	install build/mujs $(DESTDIR)$(bindir)

VERSION = $(shell git describe --tags --always)

tarball:
	git archive --format=zip --prefix=mujs-$(VERSION)/ HEAD > mujs-$(VERSION).zip
	git archive --format=tar --prefix=mujs-$(VERSION)/ HEAD | gzip > mujs-$(VERSION).tar.gz
	git archive --format=tar --prefix=mujs-$(VERSION)/ HEAD | xz > mujs-$(VERSION).tar.xz

tags: $(SRCS) main.c $(HDRS)
	ctags $^

test: build/mujs
	python tests/sputniktests/tools/sputnik.py --tests=tests/sputniktests --command ./build/mujs --summary

clean:
	rm -f astnames.h opnames.h one.c build/*

.PHONY: default test clean install debug release

=== debian/changelog ===
mupdf (1.12.0+ds1-1) unstable; urgency=high

  * New upstream version 1.12.0+ds1
  * Exclude thirdparty/{freeglut,lcms2} from upstream source
  * Refresh patches
  * Add freeglut3-dev build-dep
  * d/mupdf.docs: Include droid fonts NOTICE file
  * d/patches: Fix CVE-2018-6544 / CVE-2018-1000051 (Closes: #891245)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Wed, 14 Mar 2018 21:26:44 +0900

=== debian/control ===
Source: mupdf
Section: text
Priority: optional
Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
Uploaders: Quoc-Viet Nguyen <afelion@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), dpkg-dev (>= 1.16.1.1~),
 libfreetype6-dev, pkg-config, libjpeg-dev, libjbig2dec-dev,
 libopenjp2-7-dev, libx11-dev, libxext-dev, zlib1g-dev,
 libharfbuzz-dev, freeglut3-dev
Standards-Version: 4.1.1
Homepage: http://mupdf.com/
Vcs-Git: git://git.debian.org/git/users/koster/mupdf.git
Vcs-Browser: http://git.debian.org/?p=users/koster/mupdf.git;a=summary

Package: libmupdf-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}
Description: development files for the MuPDF viewer
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 It also reads XPS, OpenXPS and ePub documents.
 .
 This package contains the static library and headers.

Package: mupdf
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: mupdf-tools
Provides: pdf-viewer
Description: lightweight PDF viewer
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 It also reads XPS, OpenXPS and ePub documents.
 .
 The renderer in MuPDF is tailored for high quality anti-aliased graphics.
 It renders text with metrics and spacing accurate to within fractions of a
 pixel for the highest fidelity in reproducing the look of a printed page
 on screen.

Package: mupdf-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: command line tools for the MuPDF viewer
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 It also reads XPS, OpenXPS and ePub documents.
 .
 This package contains command line tools using the MuPDF library:
  - mutool - tool for clean, extract, inspect PDF documents and
             render PDF/XPS/CBZ documents.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable verbose builds to detect missing (hardening) flags.
#export verbose=1

# This has to be exported to make some magic below work.
export DH_OPTIONS
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk
# The build system doesn't use CPPFLAGS, pass them to CFLAGS to enable the
# missing (hardening) flags.
CFLAGS += $(CPPFLAGS)
CFLAGS += -DJBIG_NO_MEMENTO

ifneq (,$(filter x-fpic,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -fPIC
endif
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

BUILD_FLAGS=build=release OS=Linux verbose=yes

override_dh_auto_build:
	$(MAKE) $(BUILD_FLAGS)

override_dh_auto_install:
	$(MAKE) $(BUILD_FLAGS) prefix=$(CURDIR)/debian/tmp/usr install
	install -m744 -T $(CURDIR)/debian/mupdf.sh $(CURDIR)/debian/tmp/usr/bin/mupdf

override_dh_auto_clean:
	-rm -rf build
	-rm -rf generated
	-rm -f include/mupdf/pdf/name-table.h source/pdf/pdf-name-table.h

%:
	dh $@

=== debian/watch ===
version=3
opts=repacksuffix=+ds1,dversionmangle=s/\+ds\d*$//,uversionmangle=s/(\d[^_\-\.]?)[_\-\.](source?)$/$1/ \
http://mupdf.com/downloads/ \
(?:.*/|.*=|)mupdf[\-\._]?(\d\S*)-source\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz|zip|7z|jar)

## mupdf 1.13.0+ds1

=== debian/changelog ===
mupdf (1.13.0+ds1-3) unstable; urgency=medium

  * debian/patches: import upstream patch for CVE-2018-10289 (Closes: 896545)
  * More FTCBFS patches.
    Thanks to Helmut Grohne for the patches. (Closes: 903319)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Mon, 03 Sep 2018 09:10:50 +0900

mupdf (1.13.0+ds1-2) unstable; urgency=medium

  * Use dh_auto_build/dh_auto_install --parallel.
    Thanks to Helmut Grohne for the patch (Closes: #902968)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 08 Jul 2018 15:17:02 +0900

mupdf (1.13.0+ds1-1) unstable; urgency=medium

  * New upstream version 1.13.0+ds1
    - Fixes CVE-2018-5686 (Closes: #887130)
    - Fixes CVE-2018-6187 (Closes: #888464)
    - Fixes CVE-2018-6192 (Closes: #888487)
  * debian/control: Migrate vcs to salsa.debian.org
  * debian/patches: Refresh patches
  * debian/rules: Build with Debian CFLAGS and enable PIC libmupdf.a
    (Closes: #841403)
  * debian/rules: use Debian flavor build options (Closes: #877067)
  * debian/mupdf.sh: Do not read from a file descriptor
    (Closes: #893115, #893862)
  * debian/mupdf.desktop: Fixes and add ePub and XPS to supported mimetype.
    Thanks to Pino Toscano, Hartmut Buhrmester (Closes: #877082)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Mon, 30 Apr 2018 11:17:25 +0900

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,14 @@
 Priority: optional
 Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
 Uploaders: Quoc-Viet Nguyen <afelion@gmail.com>
-Build-Depends: debhelper (>= 7.0.50~), dpkg-dev (>= 1.16.1.1~),
+Build-Depends: debhelper (>= 7.4.10~), dpkg-dev (>= 1.16.1.1~),
  libfreetype6-dev, pkg-config, libjpeg-dev, libjbig2dec-dev,
  libopenjp2-7-dev, libx11-dev, libxext-dev, zlib1g-dev,
  libharfbuzz-dev, freeglut3-dev
 Standards-Version: 4.1.1
 Homepage: http://mupdf.com/
-Vcs-Git: git://git.debian.org/git/users/koster/mupdf.git
-Vcs-Browser: http://git.debian.org/?p=users/koster/mupdf.git;a=summary
+Vcs-Git: https://salsa.debian.org/koster/mupdf.git
+Vcs-Browser: https://salsa.debian.org/koster/mupdf
 
 Package: libmupdf-dev
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable verbose builds to detect missing (hardening) flags.
#export verbose=1

# This has to be exported to make some magic below work.
export DH_OPTIONS
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk
# The build system doesn't use CPPFLAGS, pass them to CFLAGS to enable the
# missing (hardening) flags.
CFLAGS += $(CPPFLAGS)
CFLAGS += -DJBIG_NO_MEMENTO
CFLAGS += -fPIC

BUILD_FLAGS=build=debian OS=Linux verbose=yes XCFLAGS="$(CFLAGS)" XLDFLAGS="$(LDFLAGS)" prefix=/usr

override_dh_auto_build:
	dh_auto_build -- $(BUILD_FLAGS)

override_dh_auto_install:
	dh_auto_install -- $(BUILD_FLAGS)
	install -m744 -T $(CURDIR)/debian/mupdf.sh $(CURDIR)/debian/tmp/usr/bin/mupdf

override_dh_auto_clean:
	-rm -rf build
	-rm -rf generated
	-rm -f include/mupdf/pdf/name-table.h source/pdf/pdf-name-table.h

%:
	dh $@ --parallel

## mupdf 1.14.0

=== debian/changelog ===
mupdf (1.14.0-0.1~mx17+1) mx; urgency=medium

  * New upstream release; build for MX 17.
  * Improve debian/mupdf.desktop by adding more mimetypes. Copied from Arch.
  * Disable automatic dbgsym packages.
  * Bump up to debhelper 9 compat.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 22 Oct 2018 18:28:31 -0700

mupdf (1.14.0-0build1+ubuntu16.04) xenial; urgency=low

  * New upstream release 

 -- pandajim (key for lives deb) <ubuntuhandbook1@gmail.com>  Sat, 06 Aug 2016 13:44:07 +0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable verbose builds to detect missing (hardening) flags.
#export verbose=1

# This has to be exported to make some magic below work.
export DH_OPTIONS
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk
# The build system doesn't use CPPFLAGS, pass them to CFLAGS to enable the
# missing (hardening) flags.
CFLAGS += $(CPPFLAGS)
CFLAGS += -DJBIG_NO_MEMENTO

ifneq (,$(filter x-fpic,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -fPIC
endif
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

BUILD_FLAGS=build=release OS=Linux verbose=yes

override_dh_auto_build:
	$(MAKE) $(BUILD_FLAGS)

override_dh_auto_install:
	$(MAKE) $(BUILD_FLAGS) prefix=$(CURDIR)/debian/tmp/usr install
	install -m744 -T $(CURDIR)/debian/mupdf.sh $(CURDIR)/debian/tmp/usr/bin/mupdf

override_dh_auto_clean:
	-rm -rf build
	-rm -rf generated

override_dh_strip:
	dh_strip --no-automatic-dbgsym

%:
	dh $@

## mupdf 1.14.0+ds1

=== debian/changelog ===
mupdf (1.14.0+ds1-4+deb10u3) buster; urgency=high

  * Non-maintainer upload.
  * Avoid a use-after-free in fz_drop_band_writer (CVE-2020-16600)
    (Closes: #989526)
  * Fix double free of object during linearization (CVE-2021-3407)
    (Closes: #983684)

 -- Bastian Germann <bastiangermann@fishpost.de>  Fri, 19 Feb 2021 08:55:54 +0100

mupdf (1.14.0+ds1-4+deb10u2) buster-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Detect/avoid overflow when calculating sizes of pixmaps (CVE-2020-26519)
    (Closes: #971595)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 07 Nov 2020 10:20:45 +0100

mupdf (1.14.0+ds1-4+deb10u1) buster-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Heap-based buffer overflow in fz_append_display_node (CVE-2019-13290)
    (Closes: #931475)

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 28 Aug 2020 20:42:12 +0200

mupdf (1.14.0+ds1-4) unstable; urgency=medium

  [ Salvatore Bonaccorso ]
  * Avoid being smart about keeping only a single reference to the buffer
    (CVE-2018-16647)   
    (Closes: #924351)
  * Fix text used as clip mask in pdfwrite device (CVE-2018-16648)
    (Closes: #924351)
  * Fix typo in pdf write device

  [ Kan-Ru Chen ]
  * Add more options to mupdf wrapper and display usage correctly

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sat, 16 Mar 2019 09:42:00 +0900

mupdf (1.14.0+ds1-3) unstable; urgency=high

  * d/patches: import upstream fixes for various bugs.
    Fixes CVE-2018-18662, CVE-2019-6131, CVE-2019-6130
    (Closes: #912013, #918970, #918971)
  * d/control: Bump Standards-Version to 4.3.0, no changes required
  * Fix FTCBFS
    + Supply a cross LD for wrapping fonts.
    + Supply PKG_CONFIG to all make targets.
    Thanks to Helmut Grohne for the patch (Closes: #913515)
  * Regenerate cmaps from source.
    Thanks to Helmut Grohne for the suggestion
  * d/patches/0007-typographical-and-formatting-fixes-to-the-manual.patch:
    typographical and formatting fixes to the manual.
    Thanks to Bjarni Ingi Gislason for the patch

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sat, 19 Jan 2019 12:01:19 +0900

mupdf (1.14.0+ds1-2) unstable; urgency=medium

  * Fix FTBFS on mips64el
    Disabled objcopy to avoid linking error.
  * Bump Standards-Version to 4.2.1
    Supports noopt and terse in DEB_BUILD_OPTIONS.

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 04 Nov 2018 09:13:26 +0900

mupdf (1.14.0+ds1-1) unstable; urgency=medium

  * New upstream version 1.14.0+ds1
    - Fixes CVE-2018-1000036 (Closes: #900129, upstream bug 699695)
  * d/patches: fresh patches
  * d/rules: adjust to work with updated upstream Makefile
  * d/rules: Set CC_FOR_BUILD (Closes: #903319)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 28 Oct 2018 14:48:12 +0900

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,9 @@
 Build-Depends: debhelper (>= 7.4.10~), dpkg-dev (>= 1.16.1.1~),
  libfreetype6-dev, pkg-config, libjpeg-dev, libjbig2dec-dev,
  libopenjp2-7-dev, libx11-dev, libxext-dev, zlib1g-dev,
- libharfbuzz-dev, freeglut3-dev
-Standards-Version: 4.1.1
+ libharfbuzz-dev, freeglut3-dev,
+ python:any
+Standards-Version: 4.3.0
 Homepage: http://mupdf.com/
 Vcs-Git: https://salsa.debian.org/koster/mupdf.git
 Vcs-Browser: https://salsa.debian.org/koster/mupdf

## mupdf 1.14.0.2+ds1

=== Makefile ===
# GNU Makefile

-include user.make

ifndef build
  build := release
endif

ifndef OUT
  OUT := build/$(build)
endif

default: all

# --- Configuration ---

include Makerules
include Makethird

# Do not specify CFLAGS or LIBS on the make invocation line - specify
# XCFLAGS or XLIBS instead. Make ignores any lines in the makefile that
# set a variable that was set on the command line.
CFLAGS += $(XCFLAGS) -Iinclude
LIBS += $(XLIBS) -lm

ifneq ($(threading),no)
  ifeq ($(HAVE_PTHREAD),yes)
	THREADING_CFLAGS := $(PTHREAD_CFLAGS) -DHAVE_PTHREAD
	THREADING_LIBS := $(PTHREAD_LIBS)
  endif
endif

ifeq ($(HAVE_WIN32),yes)
  WIN32_LIBS := -lcomdlg32 -lgdi32
  WIN32_LDFLAGS := -Wl,-subsystem,windows
endif

# --- Commands ---

ifneq ($(verbose),yes)
  QUIET_AR = @ echo "    AR $@" ;
  QUIET_RANLIB = @ echo "    RANLIB $@" ;
  QUIET_CC = @ echo "    CC $@" ;
  QUIET_CXX = @ echo "    CXX $@" ;
  QUIET_GEN = @ echo "    GEN $@" ;
  QUIET_LINK = @ echo "    LINK $@" ;
  QUIET_RM = @ echo "    RM $@" ;
  QUIET_TAGS = @ echo "    TAGS $@" ;
  QUIET_WINDRES = @ echo "    WINDRES $@" ;
  QUIET_OBJCOPY = @ echo "    OBJCOPY $@" ;
endif

MKTGTDIR = mkdir -p $(dir $@)
CC_CMD = $(QUIET_CC) $(MKTGTDIR) ; $(CC) $(CFLAGS) -MMD -MP -o $@ -c $<
CXX_CMD = $(QUIET_CXX) $(MKTGTDIR) ; $(CXX) $(CFLAGS) -MMD -MP -o $@ -c $<
AR_CMD = $(QUIET_AR) $(MKTGTDIR) ; $(AR) cr $@ $^
ifdef RANLIB
  RANLIB_CMD = $(QUIET_RANLIB) $(RANLIB) $@
endif
LINK_CMD = $(QUIET_LINK) $(MKTGTDIR) ; $(CC) $(LDFLAGS) -o $@ $^ $(LIBS)
TAGS_CMD = $(QUIET_TAGS) ctags $^
WINDRES_CMD = $(QUIET_WINDRES) $(MKTGTDIR) ; $(WINDRES) $< $@
OBJCOPY_CMD = $(QUIET_OBJCOPY) $(MKTGTDIR) ; $(LD) -r -b binary -o $@ $<

# --- Rules ---

$(OUT)/%.a :
	$(AR_CMD)
	$(RANLIB_CMD)

$(OUT)/%.exe: %.c
	$(LINK_CMD)

$(OUT)/source/helpers/mu-threads/%.o : source/helpers/mu-threads/%.c
	$(CC_CMD) $(THREADING_CFLAGS)

$(OUT)/source/helpers/pkcs7/%.o : source/helpers/pkcs7/%.c
	$(CC_CMD) $(LIBCRYPTO_CFLAGS)

$(OUT)/source/tools/%.o : source/tools/%.c
	$(CC_CMD) -Wall $(THIRD_CFLAGS) $(THREADING_CFLAGS)

$(OUT)/generated/%.o : generated/%.c
	$(CC_CMD) -O0

$(OUT)/platform/x11/%.o : platform/x11/%.c
	$(CC_CMD) -Wall $(X11_CFLAGS)

$(OUT)/platform/x11/curl/%.o : platform/x11/%.c
	$(CC_CMD) -Wall $(X11_CFLAGS) $(CURL_CFLAGS) -DHAVE_CURL

$(OUT)/platform/gl/%.o : platform/gl/%.c
	$(CC_CMD) -Wall $(THIRD_CFLAGS) $(GLUT_CFLAGS)

ifeq ($(HAVE_OBJCOPY),yes)
  $(OUT)/source/fitz/noto.o : source/fitz/noto.c
	$(CC_CMD) -Wall -Wdeclaration-after-statement -DHAVE_OBJCOPY $(THIRD_CFLAGS)
endif

$(OUT)/source/%.o : source/%.c
	$(CC_CMD) -Wall -Wdeclaration-after-statement $(THIRD_CFLAGS)

$(OUT)/platform/%.o : platform/%.c
	$(CC_CMD) -Wall

$(OUT)/%.o: %.rc
	$(WINDRES_CMD)

.PRECIOUS : $(OUT)/%.o # Keep intermediates from chained rules
.PRECIOUS : $(OUT)/%.exe # Keep intermediates from chained rules

# --- File lists ---

THIRD_OBJ := $(THIRD_SRC:%.c=$(OUT)/%.o)
THIRD_OBJ := $(THIRD_OBJ:%.cc=$(OUT)/%.o)

MUPDF_SRC := $(sort $(wildcard source/fitz/*.c))
MUPDF_SRC += $(sort $(wildcard source/pdf/*.c))
MUPDF_SRC += $(sort $(wildcard source/xps/*.c))
MUPDF_SRC += $(sort $(wildcard source/svg/*.c))
MUPDF_SRC += $(sort $(wildcard source/html/*.c))
MUPDF_SRC += $(sort $(wildcard source/cbz/*.c))
MUPDF_SRC += $(sort $(wildcard source/gprf/*.c))

MUPDF_OBJ := $(MUPDF_SRC:%.c=$(OUT)/%.o)

THREAD_SRC := source/helpers/mu-threads/mu-threads.c
THREAD_OBJ := $(THREAD_SRC:%.c=$(OUT)/%.o)

PKCS7_SRC := source/helpers/pkcs7/pkcs7-check.c
PKCS7_SRC += source/helpers/pkcs7/pkcs7-openssl.c
PKCS7_OBJ := $(PKCS7_SRC:%.c=$(OUT)/%.o)

# --- Generated embedded font files ---

HEXDUMP_EXE := $(OUT)/scripts/hexdump.exe

FONT_BIN := $(sort $(wildcard resources/fonts/urw/*.cff))
FONT_BIN += $(sort $(wildcard resources/fonts/han/*.ttc))
FONT_BIN += $(sort $(wildcard resources/fonts/droid/*.ttf))
FONT_BIN += $(sort $(wildcard resources/fonts/noto/*.otf))
FONT_BIN += $(sort $(wildcard resources/fonts/noto/*.ttf))
FONT_BIN += $(sort $(wildcard resources/fonts/sil/*.cff))

FONT_GEN := $(FONT_BIN:%=generated/%.c)

generated/%.cff.c : %.cff $(HEXDUMP_EXE) ; $(QUIET_GEN) $(MKTGTDIR) ; $(HEXDUMP_EXE) -s $@ $<
generated/%.otf.c : %.otf $(HEXDUMP_EXE) ; $(QUIET_GEN) $(MKTGTDIR) ; $(HEXDUMP_EXE) -s $@ $<
generated/%.ttf.c : %.ttf $(HEXDUMP_EXE) ; $(QUIET_GEN) $(MKTGTDIR) ; $(HEXDUMP_EXE) -s $@ $<
generated/%.ttc.c : %.ttc $(HEXDUMP_EXE) ; $(QUIET_GEN) $(MKTGTDIR) ; $(HEXDUMP_EXE) -s $@ $<

ifeq ($(HAVE_OBJCOPY),yes)
  MUPDF_OBJ += $(FONT_BIN:%=$(OUT)/%.o)
  $(OUT)/%.cff.o : %.cff ; $(OBJCOPY_CMD)
  $(OUT)/%.otf.o : %.otf ; $(OBJCOPY_CMD)
  $(OUT)/%.ttf.o : %.ttf ; $(OBJCOPY_CMD)
  $(OUT)/%.ttc.o : %.ttc ; $(OBJCOPY_CMD)
else
  MUPDF_OBJ += $(FONT_GEN:%.c=$(OUT)/%.o)
endif

generate: $(FONT_GEN)

# --- Generated ICC profiles ---

source/fitz/icc/%.icc.h: resources/icc/%.icc
	$(QUIET_GEN) xxd -i $< | sed 's/unsigned/static const unsigned/' > $@

generate: source/fitz/icc/gray.icc.h
generate: source/fitz/icc/rgb.icc.h
generate: source/fitz/icc/cmyk.icc.h
generate: source/fitz/icc/lab.icc.h

# --- Generated CMap files ---

CMAP_GEN := $(notdir $(sort $(wildcard resources/cmaps/*)))
CMAP_GEN := $(CMAP_GEN:%=source/pdf/cmaps/%.h)

source/pdf/cmaps/%.h: resources/cmaps/% scripts/cmapdump.py
	$(QUIET_GEN) python scripts/cmapdump.py > $@ $<

generate: $(CMAP_GEN)

# --- Generated embedded javascript files ---

source/pdf/js/%.js.h: source/pdf/js/%.js scripts/jsdump.sed
	$(QUIET_GEN) sed -f scripts/jsdump.sed < $< > $@

generate: source/pdf/js/util.js.h

# --- Library ---

MUPDF_LIB = $(OUT)/libmupdf.a
THIRD_LIB = $(OUT)/libmupdf-third.a
THREAD_LIB = $(OUT)/libmupdf-threads.a
PKCS7_LIB = $(OUT)/libmupdf-pkcs7.a

$(MUPDF_LIB) : $(MUPDF_OBJ)
$(THIRD_LIB) : $(THIRD_OBJ)
$(THREAD_LIB) : $(THREAD_OBJ)
$(PKCS7_LIB) : $(PKCS7_OBJ)

INSTALL_LIBS := $(MUPDF_LIB) $(THIRD_LIB)

# --- Main tools and viewers ---

MUTOOL_SRC := source/tools/mutool.c
MUTOOL_SRC += source/tools/muconvert.c
MUTOOL_SRC += source/tools/mudraw.c
MUTOOL_SRC += source/tools/murun.c
MUTOOL_SRC += source/tools/mutrace.c
MUTOOL_SRC += source/tools/cmapdump.c
MUTOOL_SRC += $(sort $(wildcard source/tools/pdf*.c))
MUTOOL_OBJ := $(MUTOOL_SRC:%.c=$(OUT)/%.o)
MUTOOL_EXE := $(OUT)/mutool
$(MUTOOL_EXE) : $(MUTOOL_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(PKCS7_LIB) $(THREAD_LIB)
	$(LINK_CMD) $(THIRD_LIBS) $(THREADING_LIBS) $(LIBCRYPTO_LIBS)
INSTALL_APPS += $(MUTOOL_EXE)

ifeq ($(HAVE_GLUT),yes)
  MUVIEW_GLUT_SRC += $(sort $(wildcard platform/gl/*.c))
  MUVIEW_GLUT_OBJ := $(MUVIEW_GLUT_SRC:%.c=$(OUT)/%.o)
  MUVIEW_GLUT_EXE := $(OUT)/mupdf-gl
  $(MUVIEW_GLUT_EXE) : $(MUVIEW_GLUT_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(PKCS7_LIB) $(GLUT_LIB)
	$(LINK_CMD) $(THIRD_LIBS) $(LIBCRYPTO_LIBS) $(WIN32_LDFLAGS) $(GLUT_LIBS)
  INSTALL_APPS += $(MUVIEW_GLUT_EXE)
endif

ifeq ($(HAVE_X11),yes)
  MUVIEW_X11_EXE := $(OUT)/mupdf-x11
  MUVIEW_X11_OBJ += $(OUT)/platform/x11/pdfapp.o
  MUVIEW_X11_OBJ += $(OUT)/platform/x11/x11_main.o
  MUVIEW_X11_OBJ += $(OUT)/platform/x11/x11_image.o
  $(MUVIEW_X11_EXE) : $(MUVIEW_X11_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(PKCS7_LIB)
	$(LINK_CMD) $(THIRD_LIBS) $(X11_LIBS) $(LIBCRYPTO_LIBS)
  INSTALL_APPS += $(MUVIEW_X11_EXE)
endif

ifeq ($(HAVE_WIN32),yes)
  MUVIEW_WIN32_EXE := $(OUT)/mupdf-w32
  MUVIEW_WIN32_OBJ += $(OUT)/platform/x11/pdfapp.o
  MUVIEW_WIN32_OBJ += $(OUT)/platform/x11/win_main.o
  MUVIEW_WIN32_OBJ += $(OUT)/platform/x11/win_res.o
  $(MUVIEW_WIN32_EXE) : $(MUVIEW_WIN32_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(PKCS7_LIB)
	$(LINK_CMD) $(THIRD_LIBS) $(WIN32_LDFLAGS) $(WIN32_LIBS) $(LIBCRYPTO_LIBS)
  INSTALL_APPS += $(MUVIEW_WIN32_EXE)
endif

# --- Extra tools and viewers ---

MURASTER_OBJ := $(OUT)/source/tools/muraster.o
MURASTER_EXE := $(OUT)/muraster
$(MURASTER_EXE) : $(MURASTER_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(THREAD_LIB)
	$(LINK_CMD) $(THIRD_LIBS) $(THREADING_LIBS)
EXTRA_APPS += $(MURASTER_EXE)

MJSGEN_OBJ := $(OUT)/source/tools/mjsgen.o
MJSGEN_EXE := $(OUT)/mjsgen
$(MJSGEN_EXE) : $(MJSGEN_OBJ) $(MUPDF_LIB) $(THIRD_LIB)
	$(LINK_CMD) $(THIRD_LIBS)
EXTRA_APPS += $(MJSGEN_EXE)

MUJSTEST_OBJ := $(addprefix $(OUT)/platform/x11/, jstest_main.o pdfapp.o)
MUJSTEST_EXE := $(OUT)/mujstest
$(MUJSTEST_EXE) : $(MUJSTEST_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(PKCS7_LIB)
	$(LINK_CMD) $(THIRD_LIBS) $(LIBCRYPTO_LIBS)
EXTRA_APPS += $(MUJSTEST_EXE)

ifeq ($(HAVE_X11),yes)
ifeq ($(HAVE_CURL),yes)
  MUVIEW_X11_CURL_EXE := $(OUT)/mupdf-x11-curl
  MUVIEW_X11_CURL_OBJ += $(OUT)/platform/x11/curl/pdfapp.o
  MUVIEW_X11_CURL_OBJ += $(OUT)/platform/x11/curl/x11_main.o
  MUVIEW_X11_CURL_OBJ += $(OUT)/platform/x11/curl/x11_image.o
  MUVIEW_X11_CURL_OBJ += $(OUT)/platform/x11/curl/curl_stream.o
  $(MUVIEW_X11_CURL_EXE) : $(MUVIEW_X11_CURL_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(PKCS7_LIB) $(CURL_LIB)
	$(LINK_CMD) $(THIRD_LIBS) $(X11_LIBS) $(CURL_LIBS) $(LIBCRYPTO_LIBS)
  EXTRA_APPS += $(MUVIEW_X11_CURL_EXE)
endif
endif

# --- Generated dependencies ---

-include $(MUPDF_OBJ:%.o=%.d)
-include $(PKCS7_OBJ:%.o=%.d)
-include $(THREAD_OBJ:%.o=%.d)
-include $(THIRD_OBJ:%.o=%.d)
-include $(GLUT_OBJ:%.o=%.d)
-include $(CURL_OBJ:%.o=%.d)

-include $(MUTOOL_OBJ:%.o=%.d)
-include $(MUVIEW_GLUT_OBJ:%.o=%.d)
-include $(MUVIEW_X11_OBJ:%.o=%.d)
-include $(MUVIEW_WIN32_OBJ:%.o=%.d)

-include $(MURASTER_OBJ:%.o=%.d)
-include $(MUVIEW_X11_CURL_OBJ:%.o=%.d)

# --- Examples ---

$(OUT)/example: docs/examples/example.c $(MUPDF_LIB) $(THIRD_LIB)
	$(LINK_CMD) $(CFLAGS) $(THIRD_LIBS)
$(OUT)/multi-threaded: docs/examples/multi-threaded.c $(MUPDF_LIB) $(THIRD_LIB)
	$(LINK_CMD) $(CFLAGS) $(THIRD_LIBS) -lpthread

# --- Update version string header ---

VERSION = $(shell git describe --tags)

version:
	sed -i~ -e '/FZ_VERSION /s/".*"/"'$(VERSION)'"/' include/mupdf/fitz/version.h

# --- Format man pages ---

%.txt: %.1
	nroff -man $< | col -b | expand > $@

MAN_FILES := $(sort $(wildcard docs/man/*.1))
TXT_FILES := $(MAN_FILES:%.1=%.txt)

catman: $(TXT_FILES)

# --- Install ---

prefix ?= /usr/local
bindir ?= $(prefix)/bin
libdir ?= $(prefix)/lib
incdir ?= $(prefix)/include
mandir ?= $(prefix)/share/man
docdir ?= $(prefix)/share/doc/mupdf

third: $(THIRD_LIB)
extra-libs: $(CURL_LIB) $(GLUT_LIB)
libs: $(INSTALL_LIBS)
apps: $(INSTALL_APPS)
extra-apps: $(EXTRA_APPS)
extra: extra-libs extra-apps

install: libs apps
	install -d $(DESTDIR)$(incdir)/mupdf
	install -d $(DESTDIR)$(incdir)/mupdf/fitz
	install -d $(DESTDIR)$(incdir)/mupdf/pdf
	install include/mupdf/*.h $(DESTDIR)$(incdir)/mupdf
	install include/mupdf/fitz/*.h $(DESTDIR)$(incdir)/mupdf/fitz
	install include/mupdf/pdf/*.h $(DESTDIR)$(incdir)/mupdf/pdf

	install -d $(DESTDIR)$(libdir)
	install $(INSTALL_LIBS) $(DESTDIR)$(libdir)

	install -d $(DESTDIR)$(bindir)
	install $(INSTALL_APPS) $(DESTDIR)$(bindir)

	install -d $(DESTDIR)$(mandir)/man1
	install docs/man/*.1 $(DESTDIR)$(mandir)/man1

	install -d $(DESTDIR)$(docdir)
	install -d $(DESTDIR)$(docdir)/examples
	install README COPYING CHANGES $(DESTDIR)$(docdir)
	install docs/*.html docs/*.css docs/*.png $(DESTDIR)$(docdir)
	install docs/examples/* $(DESTDIR)$(docdir)/examples

tarball:
	bash scripts/archive.sh

# --- Clean and Default ---

WATCH_SRCS := $(shell find include source platform -type f -name '*.[ch]')
watch:
	@ while ! inotifywait -q -e modify $(WATCH_SRCS) ; do time -p $(MAKE) ; done

java:
	$(MAKE) -C platform/java

tags: $(shell find include source platform thirdparty -name '*.[ch]' -or -name '*.cc' -or -name '*.hh' -or -name '*.java')
	$(TAGS_CMD)

cscope.files: $(shell find include source platform -name '*.[ch]')
	@ echo $^ | tr ' ' '\n' > $@

cscope.out: cscope.files
	cscope -b

all: libs apps

clean:
	rm -rf $(OUT)
nuke:
	rm -rf build/* generated

release:
	$(MAKE) build=release
debug:
	$(MAKE) build=debug
sanitize:
	$(MAKE) build=sanitize

android: generate
	ndk-build -j8 \
		APP_BUILD_SCRIPT=platform/java/Android.mk \
		APP_PROJECT_PATH=build/android \
		APP_PLATFORM=android-16 \
		APP_OPTIM=$(build)

.PHONY: all clean nuke install third libs apps generate

=== platform/java/Makefile ===
--- 
+++ 
@@ -25,12 +25,12 @@
 
 default: $(MUPDF_JAVA) libmupdf.jar
 
-MUPDF_CORE := ../../build/java/libmupdf.a ../../build/java/libmupdfthird.a
+MUPDF_CORE := ../../build/java/libmupdf.a ../../build/java/libmupdf-third.a
 ifeq "$(OS)" "Linux"
-$(MUPDF_CORE) :
+$(MUPDF_CORE) : .FORCE
 	$(MAKE) -C ../.. OUT=build/java XCFLAGS=-fPIC FREETYPE_DIR=/foo ZLIB_DIR=/foo libs
 else
-$(MUPDF_CORE) :
+$(MUPDF_CORE) : .FORCE
 	$(MAKE) -C ../.. OUT=build/java XCFLAGS=-fPIC libs
 endif
 
@@ -65,10 +65,10 @@
 	$(CC) -shared -o $(MUPDF_JAVA) $^ $(JAVA_LIBS)
 
 run: $(MUPDF_JAVA) $(EXAMPLE_JAVA_OBJECTS)
-	LD_LIBRARY_PATH=. java -classpath .:src example.Viewer
+	LD_LIBRARY_PATH=$$LD_LIBRARY_PATH:. java -classpath .:src example.Viewer
 
 gdb: $(MUPDF_JAVA) $(EXAMPLE_JAVA_OBJECTS)
-	LD_LIBRARY_PATH=. gdb --args java -classpath .:src example.Viewer
+	LD_LIBRARY_PATH=$$LD_LIBRARY_PATH:. gdb --args java -classpath .:src example.Viewer
 
 clean:
 	rm -f src/com/artifex/mupdf/fitz/*.class
@@ -80,3 +80,4 @@
 	$(MAKE) -C ../.. OUT=build/java clean
 
 .NOTPARALLEL : # disable -j option (it breaks since javac compiles all class files in one command)
+.PHONY: .FORCE

=== thirdparty/mujs/Makefile ===
# Build type and install directories:

build ?= release

prefix ?= /usr/local
bindir ?= $(prefix)/bin
incdir ?= $(prefix)/include
libdir ?= $(prefix)/lib

ifeq "$(wildcard .git)" ".git"
  VERSION := $(shell git describe --tags --always)
else
  VERSION := $(shell basename $$PWD | sed -e s,^mujs-,,)
endif

# Compiler flags for various configurations:

CFLAGS := -std=c99 -pedantic -Wall -Wextra -Wno-unused-parameter

ifeq "$(CC)" "clang"
  CFLAGS += -Wunreachable-code
endif

ifeq "$(shell uname)" "Linux"
  HAVE_READLINE := yes
endif

ifeq "$(build)" "debug"
  CFLAGS += -g
else ifeq "$(build)" "sanitize"
  CFLAGS += -pipe -g -fsanitize=address -fno-omit-frame-pointer
  LDFLAGS += -fsanitize=address
else
  CFLAGS += -Os
  LDFLAGS += -Wl,-s
endif

ifeq "$(HAVE_READLINE)" "yes"
  CFLAGS += -DHAVE_READLINE
  LIBREADLINE += -lreadline
endif

CFLAGS += $(XCFLAGS)

# You shouldn't need to edit anything below here.

OUT := build/$(build)

SRCS := $(wildcard js*.c utf*.c regexp.c)
HDRS := $(wildcard js*.h mujs.h utf.h regexp.h)

default: static
static: $(OUT)/mujs-pp $(OUT)/mujs $(OUT)/libmujs.a $(OUT)/mujs.pc
shared: static $(OUT)/libmujs.so

astnames.h: jsparse.h
	grep -E '(AST|EXP|STM)_' jsparse.h | sed 's/^[^A-Z]*\(AST_\)*/"/;s/,.*/",/' | tr A-Z a-z > $@

opnames.h: jscompile.h
	grep -E 'OP_' jscompile.h | sed 's/^[^A-Z]*OP_/"/;s/,.*/",/' | tr A-Z a-z > $@

one.c: $(SRCS)
	ls $(SRCS) | awk '{print "#include \""$$1"\""}' > $@

jsdump.c: astnames.h opnames.h

$(OUT)/%.o: %.c $(HDRS)
	@ mkdir -p $(dir $@)
	$(CC) $(CFLAGS) -o $@ -c $<

$(OUT)/libmujs.o: one.c $(HDRS)
	@ mkdir -p $(dir $@)
	$(CC) $(CFLAGS) -o $@ -c $<

$(OUT)/libmujs.a: $(OUT)/libmujs.o
	@ mkdir -p $(dir $@)
	$(AR) cr $@ $^

$(OUT)/libmujs.so: one.c $(HDRS)
	@ mkdir -p $(dir $@)
	$(CC) $(CFLAGS) -fPIC -shared -o $@ $< -lm

$(OUT)/mujs: $(OUT)/libmujs.o $(OUT)/main.o
	@ mkdir -p $(dir $@)
	$(CC) $(LDFLAGS) -o $@ $^ $(LIBREADLINE) -lm

$(OUT)/mujs-pp: $(OUT)/libmujs.o $(OUT)/pp.o
	@ mkdir -p $(dir $@)
	$(CC) $(LDFLAGS) -o $@ $^ -lm

$(OUT)/mujs.pc:
	@ echo Creating $@
	@ echo > $@ Name: mujs
	@ echo >> $@ Description: MuJS embeddable Javascript interpreter
	@ echo >> $@ Version: $(VERSION)
	@ echo >> $@ Cflags: -I$(incdir)
	@ echo >> $@ Libs: -L$(libdir) -lmujs
	@ echo >> $@ Libs.private: -lm

watch:
	@ while ! inotifywait -q -e modify $(SRCS) $(HDRS) ; do time -p $(MAKE) ; done

install-common: release
	install -d $(DESTDIR)$(incdir)
	install -d $(DESTDIR)$(libdir)
	install -d $(DESTDIR)$(libdir)/pkgconfig
	install -d $(DESTDIR)$(bindir)
	install -m 644 mujs.h $(DESTDIR)$(incdir)
	install -m 644 build/release/mujs.pc $(DESTDIR)$(libdir)/pkgconfig
	install -m 755 build/release/mujs $(DESTDIR)$(bindir)

install-static: install-common
	install -m 644 build/release/libmujs.a $(DESTDIR)$(libdir)

install-shared: install-common
	install -m 755 build/release/libmujs.so $(DESTDIR)$(libdir)

install: install-static

tarball:
	git archive --format=zip --prefix=mujs-$(VERSION)/ HEAD > mujs-$(VERSION).zip
	git archive --format=tar --prefix=mujs-$(VERSION)/ HEAD | gzip > mujs-$(VERSION).tar.gz
	git archive --format=tar --prefix=mujs-$(VERSION)/ HEAD | xz > mujs-$(VERSION).tar.xz

tags: $(SRCS) main.c $(HDRS)
	ctags $^

clean:
	rm -rf build

nuke: clean
	rm -f astnames.h opnames.h one.c

debug:
	$(MAKE) build=debug

sanitize:
	$(MAKE) build=sanitize

release:
	$(MAKE) build=release shared

.PHONY: default static shared clean nuke
.PHONY: install install-common install-shared install-static
.PHONY: debug sanitize release

=== debian/changelog ===
mupdf (1.14.0.2+ds1-4+deb10u3+dde) unstable; urgency=medium

  * update

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Wed, 08 Sep 2021 11:46:58 +0800

mupdf (1.14.0.2+ds1-4+deb10u3+dde) buster; urgency=high

  * Non-maintainer upload.
  * Rebuild
  * Update version

 -- wangpei <wangpei@uniontech.com>  Wed, 8 Sep 2021 09:32:23 +0800

mupdf (1.14.0.1+ds1-4+deb10u3) buster; urgency=high

  * Non-maintainer upload.
  * Avoid a use-after-free in fz_drop_band_writer (CVE-2020-16600)
    (Closes: #989526)
  * Fix double free of object during linearization (CVE-2021-3407)
    (Closes: #983684)

 -- Bastian Germann <bastiangermann@fishpost.de>  Fri, 19 Feb 2021 08:55:54 +0100
